%define subver          %{nil}
%define major		12
%define libname		%mklibname cryptsetup %{major}
%define dlibname	%mklibname cryptsetup -d

%define url_ver		%(echo %{version}|cut -d. -f1,2)

%bcond_with compatible

Name:		cryptsetup
Version:	2.7.2
Release:	%mkrel 1
Summary:	Utility for setting up encrypted filesystems
License:	GPLv2+ and LGPLv2+
Group:		System/Base
URL:		https://gitlab.com/cryptsetup/cryptsetup
%global upstream_version %{version_no_tilde}
Source0:	https://www.kernel.org/pub/linux/utils/cryptsetup/v%{url_ver}/cryptsetup-%{upstream_version}.tar.xz
Source1:	https://www.kernel.org/pub/linux/utils/cryptsetup/v%{url_ver}/cryptsetup-%{upstream_version}.tar.sign
BuildRequires:	asciidoctor
BuildRequires:	libgcrypt-devel >= 1.1.42
BuildRequires:	libgpg-error-devel
BuildRequires:	pkgconfig(blkid)
BuildRequires:	pkgconfig(devmapper)
BuildRequires:	pkgconfig(json-c)
BuildRequires:	pkgconfig(openssl)
BuildRequires:	pkgconfig(popt)
BuildRequires:	pkgconfig(uuid)
BuildRequires:	pkgconfig(libsystemd)
BuildRequires:	pkgconfig(libargon2)
BuildRequires:	pkgconfig(pwquality)
BuildRequires:	pkgconfig(libssh)
Obsoletes:	cryptsetup-luks < 1.0.5
Provides:	cryptsetup-luks = %{version}-%{release}
Requires(pre):	filesystem >= 2.1.9-18
Requires(post):	systemd >= %{systemd_required_version}

%description
LUKS is the upcoming standard for Linux hard disk encryption.
By providing a standard on-disk-format, it does not only facilitate
compatibility among distributions, but also provide secure management
of multiple user passwords. In contrast to existing solution, LUKS stores
all setup necessary setup information in the partition header, enabling
the user to transport or migrate his data seamlessly.

LUKS for dm-crypt is implemented in cryptsetup. cryptsetup-luks is
a complete replacement for the original cryptsetup. It provides all the
functionally of the original version plus all the LUKS features, which are
accessible by the luks* commands.

%package -n	%{libname}
Summary:	Library for setting up encrypted filesystems
Group:		System/Libraries

%description -n %{libname}
LUKS is the upcoming standard for Linux hard disk encryption.
By providing a standard on-disk-format, it does not only facilitate
compatibility among distributions, but also provide secure management
of multiple user passwords. In contrast to existing solution, LUKS stores
all setup necessary setup information in the partition header, enabling
the user to transport or migrate his data seamlessly.

This package contains the shared libraries required for running
programs which use cryptsetup-luks.


%package -n	%{dlibname}
Summary:	Development library for setting up encrypted filesystems
Group:		Development/C
Requires:	%{libname} = %{version}-%{release}
Provides:	cryptsetup-devel
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%mklibname -d cryptsetup 0

%description -n %{dlibname}
LUKS is the upcoming standard for Linux hard disk encryption.
By providing a standard on-disk-format, it does not only facilitate
compatibility among distributions, but also provide secure management
of multiple user passwords. In contrast to existing solution, LUKS stores
all setup necessary setup information in the partition header, enabling
the user to transport or migrate his data seamlessly.

This package contains the header files and development libraries
for building programs which use cryptsetup-luks.

%package ssh-token
Summary: Cryptsetup LUKS2 SSH token
Requires: %libname = %{version}-%{release}

%description ssh-token
This package contains the LUKS2 SSH token.


%prep
%autosetup -n cryptsetup-%{upstream_version} -p 1

%build
# to fix RPATH
autoreconf -fi

%configure --enable-pwquality --enable-libargon2 --disable-selinux
%if %{with compatible}
	--with-plain-mode=cbc-plain --with-luks1-keybits=128 \
%endif
# end of configure
%make_build

%install
%make_install

%find_lang %{name}

%post
%_tmpfilescreate %{_tmpfilesdir}/%{name}

%files -f %{name}.lang
%doc AUTHORS FAQ.md README.md
%{_sbindir}/cryptsetup
%{_sbindir}/veritysetup
%{_sbindir}/integritysetup
%{_mandir}/man8/cryptsetup.8*
%{_mandir}/man8/veritysetup.8*
%{_mandir}/man8/integritysetup.8*
%{_mandir}/man8/cryptsetup-benchmark.8*
%{_mandir}/man8/cryptsetup-bitlkDump.8*
%{_mandir}/man8/cryptsetup-bitlkOpen.8*
%{_mandir}/man8/cryptsetup-close.8*
%{_mandir}/man8/cryptsetup-config.8*
%{_mandir}/man8/cryptsetup-convert.8*
%{_mandir}/man8/cryptsetup-create.8*
%{_mandir}/man8/cryptsetup-erase.8*
%{_mandir}/man8/cryptsetup-fvault2Dump.8*
%{_mandir}/man8/cryptsetup-fvault2Open.8*
%{_mandir}/man8/cryptsetup-isLuks.8*
%{_mandir}/man8/cryptsetup-loopaesOpen.8*
%{_mandir}/man8/cryptsetup-luksAddKey.8*
%{_mandir}/man8/cryptsetup-luksChangeKey.8*
%{_mandir}/man8/cryptsetup-luksConvertKey.8*
%{_mandir}/man8/cryptsetup-luksDump.8*
%{_mandir}/man8/cryptsetup-luksErase.8*
%{_mandir}/man8/cryptsetup-luksFormat.8*
%{_mandir}/man8/cryptsetup-luksHeaderBackup.8*
%{_mandir}/man8/cryptsetup-luksHeaderRestore.8*
%{_mandir}/man8/cryptsetup-luksKillSlot.8*
%{_mandir}/man8/cryptsetup-luksOpen.8*
%{_mandir}/man8/cryptsetup-luksRemoveKey.8*
%{_mandir}/man8/cryptsetup-luksResume.8*
%{_mandir}/man8/cryptsetup-luksSuspend.8*
%{_mandir}/man8/cryptsetup-luksUUID.8*
%{_mandir}/man8/cryptsetup-open.8*
%{_mandir}/man8/cryptsetup-plainOpen.8*
%{_mandir}/man8/cryptsetup-reencrypt.8*
%{_mandir}/man8/cryptsetup-refresh.8*
%{_mandir}/man8/cryptsetup-repair.8*
%{_mandir}/man8/cryptsetup-resize.8*
%{_mandir}/man8/cryptsetup-status.8*
%{_mandir}/man8/cryptsetup-tcryptDump.8*
%{_mandir}/man8/cryptsetup-tcryptOpen.8*
%{_mandir}/man8/cryptsetup-token.8*
%{_tmpfilesdir}/%{name}.conf

%files -n %{dlibname}
%{_includedir}/libcryptsetup.h
%{_libdir}/libcryptsetup.so
%{_libdir}/pkgconfig/libcryptsetup.pc

%files -n %{libname}
%{_libdir}/libcryptsetup.so.%{major}{,.*}

%files ssh-token
%license COPYING COPYING.LGPL
%{_libdir}/%{name}/libcryptsetup-token-ssh.so
%{_mandir}/man8/cryptsetup-ssh.8.*
%{_sbindir}/cryptsetup-ssh


%changelog
* Wed Apr 10 2024 kekepower <kekepower> 2.7.2-1.mga10
+ Revision: 2056441
- Update to version 2.7.2

* Fri Apr 05 2024 wally <wally> 2.7.1-2.mga10
+ Revision: 2054595
- basesystem rebuild for i686

* Mon Mar 11 2024 daviddavid <daviddavid> 2.7.1-1.mga10
+ Revision: 2049114
- new version: 2.7.1

* Sat Feb 11 2023 kekepower <kekepower> 2.6.1-1.mga9
+ Revision: 1940121
- Update to version 2.6.1

* Thu Dec 08 2022 ghibo <ghibo> 2.6.0-1.mga9
+ Revision: 1919372
- Fix fileslist accordingly
- Update to release 2.6.0

* Tue Nov 01 2022 ghibo <ghibo> 2.5.0-1.mga9
+ Revision: 1900994
- Update to release 2.5.0.
- Adjust files list accordingly.

* Fri Apr 01 2022 umeabot <umeabot> 2.4.3-2.mga9
+ Revision: 1838124
- Mageia 9 Mass Rebuild

* Mon Jan 17 2022 mrambo3501 <mrambo3501> 2.4.3-1.mga9
+ Revision: 1768784
- version 2.4.3

* Thu Nov 18 2021 tv <tv> 2.4.2-1.mga9
+ Revision: 1757650
- Update to cryptsetup 2.4.2.

* Mon Oct 11 2021 tv <tv> 2.4.1-1.mga9
+ Revision: 1750566
- Update to cryptsetup 2.4.1.

* Sat Oct 02 2021 wally <wally> 2.4.0-1.mga9
+ Revision: 1747377
- BR libssh
- fix RPATH issue
- rebuild for openssl 3.0.0
+ tv <tv>
- Update to cryptsetup 2.4.0.
- Update to cryptsetup 2.4.0-rc1.
- add experimental cryptsetup-ssh token subpackage

* Sat May 29 2021 tv <tv> 2.3.6-1.mga9
+ Revision: 1728823
- Update to cryptsetup 2.3.6.

* Fri Mar 12 2021 tv <tv> 2.3.5-1.mga9
+ Revision: 1701774
- Update to cryptsetup 2.3.5.

* Sun Nov 29 2020 luigiwalser <luigiwalser> 2.3.4-2.mga8
+ Revision: 1650330
- rebuild for json-c

* Fri Sep 04 2020 tv <tv> 2.3.4-1.mga8
+ Revision: 1621654
- Update to cryptsetup 2.3.4.
- Fix for CVE-2020-14382

* Thu May 28 2020 tv <tv> 2.3.3-1.mga8
+ Revision: 1588440
- 2.3.3

* Sat May 02 2020 tv <tv> 2.3.2-1.mga8
+ Revision: 1577897
- link with (faster) libargon2, thus fixing:
  "-configure: WARNING: Argon2 bundled (slow) reference implementation will be used, please consider to use system library with --enable-libargon2"
- link with libpwquality
- use %%autosetup
- drop support for static lib which was never enabled on any Mga release
- fix license
- 2.3.2

* Fri Mar 20 2020 shlomif <shlomif> 2.3.1-2.mga8
+ Revision: 1558268
- New version 2.3.1

* Thu Feb 20 2020 umeabot <umeabot> 2.3.0-2.mga8
+ Revision: 1547335
- Mageia 8 Mass Rebuild

* Fri Feb 07 2020 shlomif <shlomif> 2.3.0-1.mga8
+ Revision: 1487883
- New version 2.3.0
+ wally <wally>
- replace deprecated %%configure2_5x

* Sat Dec 07 2019 shlomif <shlomif> 2.2.2-1.mga8
+ Revision: 1465042
- New version 2.2.2

* Tue Aug 20 2019 daviddavid <daviddavid> 2.2.0-1.mga8
+ Revision: 1430628
- new version: 2.2.0

* Tue Feb 12 2019 shlomif <shlomif> 2.1.0-1.mga7
+ Revision: 1366065
- Add BRs
- New version 2.1.0

* Sat Dec 22 2018 shlomif <shlomif> 2.0.6-1.mga7
+ Revision: 1344483
- New version 2.0.6

* Thu Nov 22 2018 shlomif <shlomif> 2.0.5-1.mga7
+ Revision: 1333250
- New version 2.0.5

* Sun Sep 23 2018 umeabot <umeabot> 2.0.4-2.mga7
+ Revision: 1297336
- Mageia 7 Mass Rebuild

* Sun Aug 12 2018 tmb <tmb> 2.0.4-1.mga7
+ Revision: 1251128
- BR: pkgconfig(blkid)
- update to 2.0.4
- rebuild for new libjson major

* Wed May 16 2018 shlomif <shlomif> 2.0.3-1.mga7
+ Revision: 1229881
- New version 2.0.3

* Thu Mar 22 2018 kekepower <kekepower> 2.0.2-1.mga7
+ Revision: 1211331
- Update to version 2.0.2

* Wed Mar 14 2018 kekepower <kekepower> 2.0.0-2.mga7
+ Revision: 1209535
- Fixed installation of tmpfiles

* Wed Mar 14 2018 kekepower <kekepower> 2.0.0-1.mga7
+ Revision: 1209403
- Added BR for systemd
- Added BR for json-devel
- Update to version 2.0.0
- Fixed files list
- Added %%post action for tmpfilescreate

* Mon May 01 2017 luigiwalser <luigiwalser> 1.7.5-1.mga6
+ Revision: 1098163
- 1.7.5

* Sat Mar 18 2017 luigiwalser <luigiwalser> 1.7.4-1.mga6
+ Revision: 1093552
- 1.7.4

* Fri Nov 11 2016 luigiwalser <luigiwalser> 1.7.3-1.mga6
+ Revision: 1066477
- 1.7.3

* Wed Aug 10 2016 luigiwalser <luigiwalser> 1.7.2-1.mga6
+ Revision: 1045264
- 1.7.2
+ shlomif <shlomif>
- .spec cleanups - new macros, trailing space, typos.

* Mon May 09 2016 luigiwalser <luigiwalser> 1.7.1-1.mga6
+ Revision: 1011340
- 1.7.1

* Thu Dec 31 2015 luigiwalser <luigiwalser> 1.7.0-1.mga6
+ Revision: 917395
- 1.7.0

* Sun Sep 13 2015 ycantin <ycantin> 1.6.8-1.mga6
+ Revision: 878914
- new version  1.6.8

* Thu Sep 10 2015 fwang <fwang> 1.6.7-3.mga6
+ Revision: 875416
- rebuild for new libgcrypt

* Fri Aug 21 2015 tmb <tmb> 1.6.7-2.mga6
+ Revision: 867559
- rebuild for new gcc

* Sat Jul 25 2015 blino <blino> 1.6.7-1.mga6
+ Revision: 857131
- update URL
- 1.6.7

* Wed Oct 15 2014 umeabot <umeabot> 1.6.6-4.mga5
+ Revision: 741135
- Second Mageia 5 Mass Rebuild

* Thu Sep 18 2014 umeabot <umeabot> 1.6.6-3.mga5
+ Revision: 693701
- Rebuild to fix library dependencies

* Tue Sep 16 2014 umeabot <umeabot> 1.6.6-2.mga5
+ Revision: 678598
- Mageia 5 Mass Rebuild

* Mon Aug 18 2014 luigiwalser <luigiwalser> 1.6.6-1.mga5
+ Revision: 665229
- 1.6.6

* Wed Jul 02 2014 luigiwalser <luigiwalser> 1.6.5-1.mga5
+ Revision: 642313
- 1.6.5

* Sat Mar 01 2014 luigiwalser <luigiwalser> 1.6.4-1.mga5
+ Revision: 598389
- 1.6.4
- update source URLs

* Mon Dec 16 2013 luigiwalser <luigiwalser> 1.6.3-1.mga4
+ Revision: 557950
- 1.6.3

* Sat Oct 19 2013 umeabot <umeabot> 1.6.2-2.mga4
+ Revision: 534386
- Mageia 4 Mass Rebuild

* Wed Sep 11 2013 colin <colin> 1.6.2-1.mga4
+ Revision: 477587
- New version: 1.6.2

* Fri Jan 11 2013 umeabot <umeabot> 1.5.1-2.mga3
+ Revision: 348312
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Oct 28 2012 colin <colin> 1.5.1-1.mga3
+ Revision: 311147
- New version: 1.5.1

* Tue Jul 24 2012 colin <colin> 1.5.0-1.mga3
+ Revision: 273982
- New version: 1.5.0 (needed for systemd >= 187)

* Fri Dec 09 2011 guillomovitch <guillomovitch> 1.4.1-1.mga2
+ Revision: 179493
- new version
- spec cleanup
- drop .la file
+ dlucio <dlucio>
- 1.3.1

* Wed Apr 06 2011 ahmad <ahmad> 1.3.0-1.mga1
+ Revision: 81406
- update to 1.3.0
- fix ChangeLog encoding

* Sat Jan 15 2011 supp <supp> 1.2.0-2.mga1
+ Revision: 19001
- imported package cryptsetup

